diff -Naur linux-2.6.11.8/drivers/input/touchscreen/ads7846_ts_input.c linux-2.6.x/drivers/input/touchscreen/ads7846_ts_input.c
--- linux-2.6.11.8/drivers/input/touchscreen/ads7846_ts_input.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/drivers/input/touchscreen/ads7846_ts_input.c	2009-09-06 22:47:01.000000000 +0100
@@ -0,0 +1,623 @@
+/*
+ * ads7846_ts_input.c
+ *
+ * Touch screen driver for the actelm7 board, this driver is based on code for
+ * the TI Innovator board.
+ *
+ * The touchscreen hardware on the actelm7 board consists of an m7core built 
+ * with a SPI unit which is used to 'talk' SPI to an ADS7846 touch screen controller.
+ *
+ *  Revision history
+ *  0.01  Initial version
+ */
+
+#include <linux/module.h>
+#include <linux/version.h>
+#include <linux/init.h>
+#include <linux/fs.h>
+#include <linux/miscdevice.h>
+#include <linux/delay.h>
+#include <linux/poll.h>
+#include <linux/string.h>
+#include <linux/ioport.h>       /* request_region */
+#include <linux/interrupt.h>
+#include <asm/uaccess.h>        /* get_user,copy_to_user */
+#include <asm/irq.h>
+#include <asm/io.h>
+#include <asm/arch/hardware.h>
+
+#define TS_NAME "ads7846_ts_input"
+#define TS_MINOR 14
+#define PFX TS_NAME
+
+#define err(format, arg...) printk(KERN_ERR PFX ": " format "\n" , ## arg)
+#define info(format, arg...) printk(KERN_INFO PFX ": " format "\n" , ## arg)
+#define warn(format, arg...) printk(KERN_WARNING PFX ": " format "\n" , ## arg)
+
+
+// ADS7846 Control Byte bit defines
+#define ADS7846_S         (1<<7)
+#define ADS7846_ADDR_BIT  4
+#define ADS7846_ADDR_MASK (0x7<<ADS7846_ADDR_BIT)
+#define ADS7846_MEASURE_X  (0x5<<ADS7846_ADDR_BIT)
+#define ADS7846_MEASURE_Y  (0x1<<ADS7846_ADDR_BIT)
+#define ADS7846_MEASURE_Z1 (0x3<<ADS7846_ADDR_BIT)
+#define ADS7846_MEASURE_Z2 (0x4<<ADS7846_ADDR_BIT)
+#define ADS7846_8BITS     (1<<3)
+#define ADS7846_12BITS    0
+#define ADS7846_SER       (1<<2)
+#define ADS7846_DFR       0
+#define ADS7846_PWR_BIT   0
+#define ADS7846_PD      0
+#define ADS7846_ADC_ON  (0x1<<ADS7846_PWR_BIT)
+#define ADS7846_REF_ON  (0x2<<ADS7846_PWR_BIT)
+#define ADS7846_REF_ADC_ON (0x3<<ADS7846_PWR_BIT)
+
+#define MEASURE_12BIT_X (ADS7846_S | ADS7846_MEASURE_X | ADS7846_12BITS | ADS7846_DFR | ADS7846_REF_ADC_ON)
+#define MEASURE_12BIT_X_SLEEP (ADS7846_S | ADS7846_MEASURE_X | ADS7846_12BITS | ADS7846_DFR | ADS7846_PD)
+#define MEASURE_12BIT_Y (ADS7846_S | ADS7846_MEASURE_Y | ADS7846_12BITS | ADS7846_DFR | ADS7846_REF_ADC_ON)
+#define MEASURE_12BIT_Z1 (ADS7846_S | ADS7846_MEASURE_Z1 | ADS7846_12BITS | ADS7846_DFR | ADS7846_ADC_ON)
+#define MEASURE_12BIT_Z2 (ADS7846_S | ADS7846_MEASURE_Z2 | ADS7846_12BITS | ADS7846_DFR | ADS7846_ADC_ON)
+
+/*
+ * Which pressure equation to use from ADS7846 datasheet.
+ * The first equation requires knowing only the X plate
+ * resistance, but needs 4 measurements (X, Y, Z1, Z2).
+ * The second equation requires knowing both X and Y plate
+ * resistance, but only needs 3 measurements (X, Y, Z1).
+ */
+enum {
+	PRESSURE_EQN_1 = 0,
+	PRESSURE_EQN_2
+};
+
+
+/*
+ * The touch screen's X and Y plate resistances, used by
+ * pressure equations.
+ */
+#define DEFAULT_X_PLATE_OHMS 560
+#define DEFAULT_Y_PLATE_OHMS 548
+
+/*
+ * The definition of the following structure is copied from ucb1x00-ts.c
+ * so the touchscreen will "just work" with tslib.
+ */
+struct ts_event {
+        u16 pressure;
+        u16 x;
+        u16 y;
+        u16 pad;
+        struct timeval stamp;
+};
+
+
+#define EVENT_BUFSIZE 32 // must be power of two
+
+struct innovator_ts_t {
+	// The X and Y plate resistance, needed to calculate pressure
+	int x_plate_ohms, y_plate_ohms;
+	int pressure_eqn;      // eqn to use for pressure calc
+	int pendown_irq;       // IRQ of pendown interrupt
+	int pen_is_down;       // 1 = pen is down, 0 = pen is up
+	int irq_enabled;
+	struct ts_event event_buf[EVENT_BUFSIZE];// The event queue
+	int nextIn, nextOut;
+	int event_count;
+	struct fasync_struct *fasync;     // asynch notification
+	struct timer_list acq_timer;      // Timer for triggering acquisitions
+	wait_queue_head_t wait;           // read wait queue
+	spinlock_t lock;
+	int debounce_max;				//maximum number of retries
+	int debounce_tol;				//tolerance between reads
+	int debounce_rep;				//repeated good results needed
+	int read_cnt;					
+	int read_rep;					
+	u16 last_read;					
+	int ignore;						//set if we have a bad reading
+	int read_ok;					//set this on good reading
+};
+
+static struct innovator_ts_t innovator_ts;
+
+static u8 spiWrite(u8 data)
+{
+	u8 received = 0x00;
+	u8 status = 0x00;
+	
+	//transmit data
+
+	SPI_TX = data;
+
+	//wait until transmit buffer is empty
+	while((status & 0x04) == 0)
+	{
+		status = SPI_STATUS;
+	}
+	
+	// wait for SPI recieve flag in Status register
+	while((status & 0x02) == 0)
+	{
+		status = SPI_STATUS;
+	}
+	
+	// store received data
+	received = SPI_RX;
+	
+	return received;	
+}
+
+static u16 ads7846_do(u8 cmd)
+{  	
+	
+	//clear variables
+	u16 val = 0x0000;
+	u8 dummy = 0x00;
+	u8 temp1 = 0x00;
+	u8 temp2 = 0x00;
+	u32 status = 0;
+
+	 //transmit ads7846 command byte
+	dummy = spiWrite(cmd);
+
+	//wait for busy line to go high
+	while ((status & 0x00000080) == 0)
+	{
+		status = DataIn;	
+	}
+	
+	//get x y or z value from ads7846 chip 
+	dummy = 0x00;
+	temp1 = spiWrite(dummy);
+	dummy = 0x00;	
+	temp2 = spiWrite(dummy); 
+
+	//put recieved value in the right order
+	val = ((temp1 & 0x7f) << 5);	
+	val |= (temp2 >> 3);
+
+	return val;
+}
+
+// hold the spinlock before calling.
+static void event_add(struct innovator_ts_t* ts,
+		      struct ts_event* event)
+{
+	// add this event to the event queue
+	ts->event_buf[ts->nextIn] = *event;
+	ts->nextIn = (ts->nextIn + 1) & (EVENT_BUFSIZE - 1);
+	if (ts->event_count < EVENT_BUFSIZE) {
+		ts->event_count++;
+	} else {
+		// throw out the oldest event
+		ts->nextOut = (ts->nextOut + 1) & (EVENT_BUFSIZE - 1);
+	}
+	
+	// async notify
+	if (ts->fasync)
+		kill_fasync(&ts->fasync, SIGIO, POLL_IN);
+	// wake up any read call
+	if (waitqueue_active(&ts->wait))
+		wake_up_interruptible(&ts->wait);
+}
+
+static int event_pull(struct innovator_ts_t* ts,
+		      struct ts_event* event)
+{
+	unsigned long flags;
+	int ret;
+	
+	spin_lock_irqsave(&ts->lock, flags);
+	ret = ts->event_count;
+	if (ts->event_count) {
+		*event = ts->event_buf[ts->nextOut];
+		ts->nextOut = (ts->nextOut + 1) & (EVENT_BUFSIZE - 1);
+		ts->event_count--;
+	}
+	spin_unlock_irqrestore(&ts->lock, flags);
+
+	return ret;
+}
+
+
+static irqreturn_t pendown_interrupt(int irq, void * dev_id, struct pt_regs * regs)
+{
+	struct innovator_ts_t* ts = dev_id;
+
+	spin_lock(&ts->lock);
+
+if (ts->irq_enabled) {
+ts->irq_enabled = 0;
+	disable_irq(irq);
+}
+	ts->pen_is_down = 1;
+	// restart acquire
+	ts->acq_timer.expires = jiffies + HZ / 100;
+	add_timer(&ts->acq_timer);
+
+	spin_unlock(&ts->lock);
+
+	return IRQ_HANDLED;
+}
+
+static void ads7846_debounce(struct innovator_ts_t* ts,u16 val)
+{
+
+        if (!ts->read_cnt || (abs(ts->last_read - val) > ts->debounce_tol)) 
+		{
+                 /* Repeat it, if this was the first read or the read
+                  * wasn't consistent enough. */
+                 if (ts->read_cnt < ts->debounce_max) 
+				 {
+                         ts->last_read = val;
+                         ts->read_cnt++;
+                 } 
+				 else 
+				 {
+                         /* Maximum number of debouncing reached and still
+                          * not enough number of consistent readings. Abort
+                          * the whole sample, repeat it in the next sampling
+                          * period.
+                          */
+                         ts->ignore = 1;
+						 ts->read_ok = 0;
+                         ts->read_cnt = 0;
+                 }
+                 /* Start over collecting consistent readings. */
+                 ts->read_rep = 0;
+         } 
+	     else 
+		 {
+                 if (++ts->read_rep > ts->debounce_rep) 
+				 {
+                         /* Got a good reading for this coordinate,
+                          * go for the next one. */
+                         ts->ignore = 0;
+                         ts->read_cnt = 0;
+                         ts->read_rep = 0;
+						 ts->read_ok = 1;
+				 } 
+				 else
+				 {
+                         /* Read more values that are consistent. */
+                         ts->read_cnt++;
+				 }
+         }
+}
+
+
+/*
+ * Acquire Raw pen coodinate data and compute touch screen
+ * pressure resistance. Hold spinlock when calling.
+ */
+static void AcquireEvent(struct innovator_ts_t* ts,
+			 struct ts_event* event)
+{
+	u16 x_raw, y_raw, z1_raw, z2_raw=0;
+	unsigned int Rt = 0;
+
+	//set CS line low
+	DataOut &= 0xffffffef;	
+
+	//keep reading y until we have made a choice
+	while(ts->ignore != 1 && ts->read_ok != 1)
+	{
+		y_raw = ads7846_do(MEASURE_12BIT_Y);
+		ads7846_debounce(ts,y_raw);
+	}
+
+	if(ts->ignore == 1)
+		return;
+
+	//clear flag
+	ts->read_ok = 0;
+
+	//keep reading x until we have made a choice
+	while(ts->ignore != 1 && ts->read_ok != 1)
+	{
+		x_raw = ads7846_do(MEASURE_12BIT_X);
+		ads7846_debounce(ts,x_raw);
+	}
+
+	if(ts->ignore == 1)
+		return;
+
+	//clear flag
+	ts->read_ok = 0;
+
+	//keep reading z1 until we have made a choice
+	while(ts->ignore != 1 && ts->read_ok != 1)
+	{
+		z1_raw = ads7846_do(MEASURE_12BIT_Z1);
+		ads7846_debounce(ts,z1_raw);
+	}
+
+	if(ts->ignore == 1)
+		return;
+
+	//clear flag
+	ts->read_ok = 0;
+
+	if (ts->pressure_eqn == PRESSURE_EQN_1)
+	{
+		//keep reading z2 until we have made a choice
+		while(ts->ignore != 1 && ts->read_ok != 1)
+		{
+			z2_raw = ads7846_do(MEASURE_12BIT_Z2); 
+			ads7846_debounce(ts,z2_raw);
+		}
+	}
+
+	if(ts->ignore == 1)
+		return;
+
+	//clear flag
+	ts->read_ok = 0;
+
+	// Calculate touch pressure resistance
+	if (z1_raw) {
+		if (ts->pressure_eqn == PRESSURE_EQN_1) {
+			Rt = (ts->x_plate_ohms * (u32)x_raw *
+			      ((u32)z2_raw - (u32)z1_raw)) / (u32)z1_raw;
+		} else {
+			Rt = (ts->x_plate_ohms * (u32)x_raw *
+			      (4096 - (u32)z1_raw)) / (u32)z1_raw;
+			Rt -= (ts->y_plate_ohms * (u32)y_raw);
+		}
+
+		Rt = (Rt + 2048) >> 12; // round up to nearest ohm
+	}
+
+	event->x = x_raw;
+	event->y = y_raw;
+	event->pressure = (u16)Rt;
+	// timestamp this new event.
+	do_gettimeofday(&event->stamp);
+	//put ads7846 to sleep
+	x_raw = ads7846_do(MEASURE_12BIT_X_SLEEP);
+	//set CS line high
+	DataOut |= 0x00000010;
+
+}
+
+/*
+ * Raw X,Y,pressure acquisition timer function. It gets scheduled
+ * only while pen is down. Its duration between calls is the polling
+ * rate.
+ */
+static void
+innovator_acq_timer(unsigned long data)
+{
+	struct innovator_ts_t* ts = (struct innovator_ts_t*)data;
+	unsigned long flags;
+	struct ts_event event;
+	int pen_was_down = ts->pen_is_down;
+	u32 DataInput = DataIn;
+	u16 dummy;	
+
+	spin_lock_irqsave(&ts->lock, flags);
+
+	if (DataInput & 0x00000040) 
+	{
+		ts->pen_is_down = 1;
+		AcquireEvent(ts, &event);
+		if(ts->ignore == 1)
+		{
+			ts->ignore = 0;		
+			//put ads7846 to sleep
+			dummy = ads7846_do(MEASURE_12BIT_X_SLEEP);
+			//set CS line high
+			DataOut |= 0x00000010;
+		}
+		else
+		{
+			event_add(ts, &event);
+		}
+
+		// schedule next acquire
+		ts->acq_timer.expires = jiffies + HZ / 100;
+		add_timer(&ts->acq_timer);
+	} 
+	else 
+	{
+		if (!ts->irq_enabled) 
+		{
+			ts->irq_enabled = 1;
+			enable_irq(ts->pendown_irq);
+		}
+		ts->pen_is_down = 0;
+		if (pen_was_down) {
+			event.x = event.y = event.pressure = 0;
+			do_gettimeofday(&event.stamp);
+			event_add(ts, &event);
+		}
+	}
+	
+	spin_unlock_irqrestore(&ts->lock, flags);
+}
+
+
+/*  File operations */
+
+static int
+innovator_fasync(int fd, struct file *filp, int mode)
+{
+	struct innovator_ts_t* ts = (struct innovator_ts_t*)filp->private_data;
+	return fasync_helper(fd, filp, mode, &ts->fasync);
+}
+
+
+static unsigned int
+innovator_poll(struct file * filp, poll_table * wait)
+{
+	struct innovator_ts_t* ts = (struct innovator_ts_t*)filp->private_data;
+	poll_wait(filp, &ts->wait, wait);
+	if (ts->event_count)
+		return POLLIN | POLLRDNORM;
+	return 0;
+}
+
+static ssize_t
+innovator_read(struct file * filp, char * buffer, size_t count, loff_t * ppos)
+{
+	DECLARE_WAITQUEUE(wait, current);
+	struct innovator_ts_t* ts = (struct innovator_ts_t*)filp->private_data;
+	char *ptr = buffer;
+	struct ts_event event;
+	int err = 0;
+
+	add_wait_queue(&ts->wait, &wait);
+	while (count >= sizeof(struct ts_event)) {
+		err = -ERESTARTSYS;
+		if (signal_pending(current))
+			break;
+
+		if (event_pull(ts, &event)) {
+			err = copy_to_user(ptr, &event,
+					   sizeof(struct ts_event));
+			if (err)
+				break;
+			ptr += sizeof(struct ts_event);
+			count -= sizeof(struct ts_event);
+		} else {
+			set_current_state(TASK_INTERRUPTIBLE);
+			err = -EAGAIN;
+			if (filp->f_flags & O_NONBLOCK)
+				break; 
+			schedule();
+		}
+	}
+	
+	current->state = TASK_RUNNING;
+	remove_wait_queue(&ts->wait, &wait);
+	
+	return ptr == buffer ? err : ptr - buffer;
+}
+
+
+static int
+innovator_open(struct inode * inode, struct file * filp)
+{
+	struct innovator_ts_t* ts;
+	unsigned long flags;
+	int retval;
+	
+	filp->private_data = ts = &innovator_ts;
+
+	spin_lock_irqsave(&ts->lock, flags);
+
+	ts->pen_is_down = 0; // start with pen up
+	
+	// flush event queue
+	ts->nextIn = ts->nextOut = ts->event_count = 0;
+	
+	// Init acquisition timer function
+	init_timer(&ts->acq_timer);
+	ts->acq_timer.function = innovator_acq_timer;
+	ts->acq_timer.data = (unsigned long)ts;
+
+ts->irq_enabled = 1;
+
+	spin_unlock_irqrestore(&ts->lock, flags);
+
+	/* Since ts interrupt can happen immediately after request_irq,
+	 * we wait until we've completed init of all relevent driver
+	 * state variables. Now we grab the PenDown IRQ
+	 */
+	retval = request_irq(ts->pendown_irq, &pendown_interrupt,
+			     0, TS_NAME, ts);
+	if (retval) {
+		err("unable to get PenDown IRQ %d", ts->pendown_irq);
+		return retval;
+	}
+
+	return 0;
+}
+
+static int
+innovator_release(struct inode * inode, struct file * filp)
+{
+	struct innovator_ts_t* ts = (struct innovator_ts_t*)filp->private_data;
+
+	free_irq(ts->pendown_irq, ts);
+	innovator_fasync(-1, filp, 0);
+	del_timer_sync(&ts->acq_timer);
+
+	//MOD_DEC_USE_COUNT;
+	return 0;
+}
+
+
+static struct file_operations ts_fops = {
+	owner:          THIS_MODULE,
+	read:           innovator_read,
+	poll:           innovator_poll,
+	fasync:         innovator_fasync,
+	open:			innovator_open,
+	release:		innovator_release,
+};
+
+/*  End File operations */
+
+
+static struct miscdevice innovator_ts_dev = {
+	minor:  TS_MINOR,
+	name:   TS_NAME,
+	fops:   &ts_fops,
+};
+
+int __init
+innovatorts_init_module(void)
+{
+	struct innovator_ts_t* ts = &innovator_ts;
+	int ret;
+
+	/* register our character device */
+	if ((ret = misc_register(&innovator_ts_dev)) < 0) {
+		err("can't register misc device");
+		return ret;
+	}
+	info("registered");
+
+	memset(ts, 0, sizeof(struct innovator_ts_t));
+	init_waitqueue_head(&ts->wait);
+	spin_lock_init(&ts->lock);
+
+	ts->pendown_irq = ACTELM7_INTERRUPT_PENDOWN;
+	ts->pressure_eqn = PRESSURE_EQN_1;
+	// init X and Y plate resistances
+	ts->x_plate_ohms = DEFAULT_X_PLATE_OHMS;
+	ts->y_plate_ohms = DEFAULT_Y_PLATE_OHMS;
+
+	//setup debounce
+	ts->debounce_max = 20;				//maximum number of retries
+	ts->debounce_tol = 6;				//tolerance between reads
+	ts->debounce_rep = 1;				//repeated good results needed
+
+	//set select line high
+	DataOut |= 0x00000010;
+
+	//setup SPI controller interrupt disabled, master mode, 
+	//MSB first, fclk / 16
+	SPI_CTRL1 = 0x43;
+
+	//enable SPI
+	SPI_CTRL2 = 0x80;
+
+	return 0;
+}
+
+void
+innovatorts_cleanup_module(void)
+{
+	misc_deregister(&innovator_ts_dev);
+}
+
+/* Module information */
+MODULE_AUTHOR("Steven taffs steventaffs@yahoo.com");
+MODULE_DESCRIPTION("ADS7846 Touch Screen Driver");
+MODULE_LICENSE("GPL");
+
+module_init(innovatorts_init_module);
+module_exit(innovatorts_cleanup_module);
+
diff -Naur linux-2.6.11.8/drivers/input/touchscreen/Kconfig linux-2.6.x/drivers/input/touchscreen/Kconfig
--- linux-2.6.11.8/drivers/input/touchscreen/Kconfig	2005-04-30 02:27:34.000000000 +0100
+++ linux-2.6.x/drivers/input/touchscreen/Kconfig	2009-09-06 22:42:40.000000000 +0100
@@ -35,3 +35,14 @@
 	  To compile this driver as a module, choose M here: the
 	  module will be called gunze.
 
+config TOUCHSCREEN_ADS7846
+	tristate "ACTELM7 ads7864 touchscreen input driver"
+	depends on INPUT && INPUT_TOUCHSCREEN
+	help
+	  say Y here if you have the ACTELM7 touchscreen connected to
+	  your system.
+
+	  if unsure, say N.
+ 
+	
+
diff -Naur linux-2.6.11.8/drivers/input/touchscreen/Makefile linux-2.6.x/drivers/input/touchscreen/Makefile
--- linux-2.6.11.8/drivers/input/touchscreen/Makefile	2005-04-30 02:31:29.000000000 +0100
+++ linux-2.6.x/drivers/input/touchscreen/Makefile	2009-09-06 22:42:40.000000000 +0100
@@ -6,3 +6,4 @@
 
 obj-$(CONFIG_TOUCHSCREEN_BITSY)	+= h3600_ts_input.o
 obj-$(CONFIG_TOUCHSCREEN_GUNZE)	+= gunze.o
+obj-$(CONFIG_TOUCHSCREEN_ADS7846) += ads7846_ts_input.o
diff -Naur linux-2.6.11.8/drivers/mtd/maps/actelm7.c linux-2.6.x/drivers/mtd/maps/actelm7.c
--- linux-2.6.11.8/drivers/mtd/maps/actelm7.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.x/drivers/mtd/maps/actelm7.c	2009-09-06 22:42:40.000000000 +0100
@@ -0,0 +1,87 @@
+/*
+ * Flash map for actelm7 board
+ */
+
+#include <linux/config.h>
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <asm/io.h>
+#include <linux/mtd/mtd.h>
+#include <linux/mtd/map.h>
+#include <linux/mtd/cfi.h>
+#include <linux/mtd/partitions.h>
+#include <linux/init.h>
+#include <linux/fs.h>
+#include <linux/major.h>
+
+static struct mtd_info *flash_mtd;
+static struct mtd_partition *parsed_parts;
+
+struct map_info actelm7_flash_map = {
+	.name		= "ACTELM7 FLASH",
+	.phys		= 0x00000000,
+	.size		= 0x00800000,
+	.bankwidth	= 3,
+};
+
+static struct mtd_partition actelm7_partitions[] = {
+	{
+		.name	= "u-boot",
+		.offset	= 0x00000000,
+		.size	= 0x00080000,
+	},
+	{
+		.name	= "Kernel",
+		.offset	= 0x00080000,
+		.size	= 0x00180000,
+	},
+	{
+		.name	= "Flash FS",
+		.offset	= 0x00200000,
+		.size	= 0x005d0000,
+	}
+};
+
+static int __init init_actelm7_maps(void)
+{
+	int nr_parts;
+
+	actelm7_flash_map.phys = 0;
+	actelm7_flash_map.virt = (unsigned long) ioremap_nocache(actelm7_flash_map.phys,actelm7_flash_map.size);
+
+	simple_map_init(&actelm7_flash_map);
+
+	printk(KERN_NOTICE "Probing for flash chips at 0x00000000:\n");
+	flash_mtd = do_map_probe("map_rom", &actelm7_flash_map);
+	if (!flash_mtd) {
+		printk(KERN_NOTICE "Flash chips not detected at either possible location.\n");
+		return -ENXIO;
+	}
+	printk(KERN_NOTICE "INTEL: Flash at 0x%08lx\n", actelm7_flash_map.virt);
+	flash_mtd->owner = THIS_MODULE;
+
+	parsed_parts = actelm7_partitions;
+	nr_parts = ARRAY_SIZE(actelm7_partitions);
+
+	add_mtd_partitions(flash_mtd, parsed_parts, nr_parts);
+
+	return 0;
+
+}
+
+static void __exit cleanup_actelm7_maps(void)
+{
+	if (parsed_parts)
+		del_mtd_partitions(flash_mtd);
+	else
+		del_mtd_device(flash_mtd);
+	map_destroy(flash_mtd);
+}
+
+module_init(init_actelm7_maps);
+module_exit(cleanup_actelm7_maps);
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Steven taffs steventaffs@yahoo.com");
+MODULE_DESCRIPTION("MTD map driver for actelm7 board.");
diff -Naur linux-2.6.11.8/drivers/mtd/maps/Kconfig linux-2.6.x/drivers/mtd/maps/Kconfig
--- linux-2.6.11.8/drivers/mtd/maps/Kconfig	2005-04-30 02:32:19.000000000 +0100
+++ linux-2.6.x/drivers/mtd/maps/Kconfig	2009-09-06 22:42:40.000000000 +0100
@@ -667,5 +667,12 @@
 	help
 	  This enables access to the flash chip on the Sharp SL Series of PDAs.
 
+config MTD_ACTELM7
+	tristate "Map driver for actel a3p-dev-kit-scs board"
+	depends on MTD
+	help
+	  Map driver for a3p-dev-kit-scs board
+	
+
 endmenu
 
diff -Naur linux-2.6.11.8/drivers/mtd/maps/Makefile linux-2.6.x/drivers/mtd/maps/Makefile
--- linux-2.6.11.8/drivers/mtd/maps/Makefile	2005-04-30 02:22:38.000000000 +0100
+++ linux-2.6.x/drivers/mtd/maps/Makefile	2009-09-06 22:42:40.000000000 +0100
@@ -72,3 +72,5 @@
 obj-$(CONFIG_MTD_WRSBC8260)	+= wr_sbc82xx_flash.o
 obj-$(CONFIG_MTD_DMV182)	+= dmv182.o
 obj-$(CONFIG_MTD_SHARP_SL)	+= sharpsl-flash.o
+obj-$(CONFIG_MTD_ACTELM7)	+= actelm7.o
+
diff -Naur linux-2.6.11.8/drivers/mtd/maps/physmap.c linux-2.6.x/drivers/mtd/maps/physmap.c
--- linux-2.6.11.8/drivers/mtd/maps/physmap.c	2005-04-30 02:29:03.000000000 +0100
+++ linux-2.6.x/drivers/mtd/maps/physmap.c	2009-09-06 22:42:40.000000000 +0100
@@ -47,11 +47,12 @@
 
 static int __init init_physmap(void)
 {
-	static const char *rom_probe_types[] = { "cfi_probe", "jedec_probe", "map_rom", NULL };
+	//static const char *rom_probe_types[] = { "cfi_probe", "jedec_probe", "map_rom", NULL };
+	static const char *rom_probe_types[] = { "map_rom", NULL}; 
 	const char **type;
 
        	printk(KERN_NOTICE "physmap flash device: %lx at %lx\n", physmap_map.size, physmap_map.phys);
-	physmap_map.virt = ioremap(physmap_map.phys, physmap_map.size);
+	physmap_map.virt = ioremap_nocache(physmap_map.phys, physmap_map.size);
 
 	if (!physmap_map.virt) {
 		printk("Failed to ioremap\n");
diff -Naur linux-2.6.11.8/drivers/mtd/maps/uclinux.c linux-2.6.x/drivers/mtd/maps/uclinux.c
--- linux-2.6.11.8/drivers/mtd/maps/uclinux.c	2009-09-06 22:49:57.000000000 +0100
+++ linux-2.6.x/drivers/mtd/maps/uclinux.c	2009-09-06 22:42:40.000000000 +0100
@@ -34,7 +34,7 @@
 /****************************************************************************/
 
 struct mtd_partition uclinux_romfs[] = {
-	{ .name = "ROMfs" }
+	{ .name = "ROMfs"}
 };
 
 #define	NUM_PARTITIONS	(sizeof(uclinux_romfs) / sizeof(uclinux_romfs[0]))
@@ -61,7 +61,7 @@
 
 	mapp = &uclinux_ram_map;
 	mapp->phys = addr;
-	mapp->size = PAGE_ALIGN(*((unsigned long *)(addr + 8)));
+	mapp->size = 0x100000; //PAGE_ALIGN(*((unsigned long *)(addr + 8)));
 	mapp->bankwidth = 4;
 
 	printk("uclinux[mtd]: RAM probe address=0x%x size=0x%x\n",
diff -Naur linux-2.6.11.8/drivers/net/8390.c linux-2.6.x/drivers/net/8390.c
--- linux-2.6.11.8/drivers/net/8390.c	2009-09-06 22:49:57.000000000 +0100
+++ linux-2.6.x/drivers/net/8390.c	2009-09-06 22:42:40.000000000 +0100
@@ -189,6 +189,9 @@
       
       	spin_lock_irqsave(&ei_local->page_lock, flags);
 	NS8390_init(dev, 1);
+#ifdef CONFIG_ARCH_ACTELM7
+	enable_irq(dev->irq);
+#endif
 	/* Set the flag before we drop the lock, That way the IRQ arrives
 	   after its set and we get no silly warnings */
 	netif_start_queue(dev);
diff -Naur linux-2.6.11.8/drivers/net/8390.h linux-2.6.x/drivers/net/8390.h
--- linux-2.6.11.8/drivers/net/8390.h	2009-09-06 22:49:57.000000000 +0100
+++ linux-2.6.x/drivers/net/8390.h	2009-09-06 22:42:40.000000000 +0100
@@ -142,6 +142,8 @@
 
 #elif defined(CONFIG_NET_CBUS) || defined(CONFIG_NE_H8300) || defined(CONFIG_NE_H8300_MODULE)
 #define EI_SHIFT(x)	(ei_local->reg_offset[x])
+#elif defined(CONFIG_ARCH_ACTELM7) /* according to board connection */
+#define EI_SHIFT(x) 	(x<<1)
 #else
 #define EI_SHIFT(x)	(x)
 #endif
diff -Naur linux-2.6.11.8/drivers/net/Kconfig linux-2.6.x/drivers/net/Kconfig
--- linux-2.6.11.8/drivers/net/Kconfig	2009-09-06 22:49:57.000000000 +0100
+++ linux-2.6.x/drivers/net/Kconfig	2009-09-06 22:42:40.000000000 +0100
@@ -1095,6 +1095,17 @@
 	  <file:Documentation/networking/net-modules.txt>. The module
 	  will be called ne.
 
+config RTL8019AS
+	tristate "rtl8019as support(NE2000 compatible)"
+	depends on ARCH_ACTELM7
+	select CRC32
+	help
+	  If you have a network (Ethernet) card of this type, say Y and read
+	  the Ethernet-HOWTO, available from 
+	  <http://www.tldp.org/docs.html#howto>.  
+	  Many Ethernet cards without a specific driver are compatible with
+	  NE2000, including the rtl8019as.
+
 config ZNET
 	tristate "Zenith Z-Note support (EXPERIMENTAL)"
 	depends on NET_ISA && EXPERIMENTAL
diff -Naur linux-2.6.11.8/drivers/net/Makefile linux-2.6.x/drivers/net/Makefile
--- linux-2.6.11.8/drivers/net/Makefile	2005-04-30 02:25:45.000000000 +0100
+++ linux-2.6.x/drivers/net/Makefile	2009-09-06 22:42:40.000000000 +0100
@@ -83,6 +83,7 @@
 obj-$(CONFIG_WD80x3) += wd.o 8390.o
 obj-$(CONFIG_EL2) += 3c503.o 8390.o
 obj-$(CONFIG_NE2000) += ne.o 8390.o
+obj-$(CONFIG_RTL8019AS) += rtl8019as.o 8390.o
 obj-$(CONFIG_NE2_MCA) += ne2.o 8390.o
 obj-$(CONFIG_HPLAN) += hp.o 8390.o
 obj-$(CONFIG_HPLAN_PLUS) += hp-plus.o 8390.o
diff -Naur linux-2.6.11.8/drivers/net/ne.c linux-2.6.x/drivers/net/ne.c
--- linux-2.6.11.8/drivers/net/ne.c	2009-09-06 22:49:57.000000000 +0100
+++ linux-2.6.x/drivers/net/ne.c	2009-09-06 22:42:40.000000000 +0100
@@ -56,6 +56,10 @@
 #include <asm/io.h>
 
 #include "8390.h"
+#ifdef CONFIG_ARCH_ACTELM7
+#include "rtl8019as.h"
+unsigned char   ne_defethaddr[] = { 0x00, 0xd0, 0xcf, 0x00, 0x00, 0x01 };
+#endif
 
 #ifdef CONFIG_COLDFIRE
 #define COLDFIRE_NE2000_FUNCS
@@ -135,10 +139,17 @@
 /* ---- No user-serviceable parts below ---- */
 
 #define NE_BASE	 (dev->base_addr)
+#ifdef CONFIG_ARCH_ACTELM7
+#define NE_CMD	 	EI_SHIFT(0x00)
+#define NE_DATAPORT	EI_SHIFT(0x10)	/* NatSemi-defined port window offset. */
+#define NE_RESET	EI_SHIFT(0x1f)	/* Issue a read to reset, a write to clear. */
+#define NE_IO_EXTENT	EI_SHIFT(0x20)
+#else
 #define NE_CMD	 	0x00
 #define NE_DATAPORT	0x10	/* NatSemi-defined port window offset. */
 #define NE_RESET	0x1f	/* Issue a read to reset, a write to clear. */
 #define NE_IO_EXTENT	0x20
+#endif
 
 #define NE1SM_START_PG	0x20	/* First page of TX buffer */
 #define NE1SM_STOP_PG 	0x40	/* Last page +1 of RX ring */
@@ -268,6 +279,10 @@
 	sprintf(dev->name, "eth%d", unit);
 	netdev_boot_setup_check(dev);
 
+#ifdef CONFIG_ARCH_ACTELM7 /* determined by ACTEL M7 board design */ 
+	  dev->base_addr = 0x82000600;
+	  dev->irq = 16; //ext2
+#endif
 	err = do_ne_probe(dev);
 	if (err)
 		goto out;
@@ -377,6 +392,14 @@
 	   cause the driver to skip these parts of the probe. */
 
 	bad_card = ((dev->base_addr != 0) && (dev->mem_end == 0xbad));
+#ifdef CONFIG_ARCH_ACTELM7
+	/* initialize rtl8019as related registers */
+	outb_p(E8390_PAGE3, ioaddr + E8390_CMD); // set to page 3
+	outb_p(0xcf, ioaddr + CR9346);  //enable write config reg
+	outb_p(0x60, ioaddr + CONFIG3); //clear pwrdn, sleep mode 
+	outb_p(0x0f, ioaddr + CR9346);  //disable write config reg
+	outb_p(E8390_PAGE0, ioaddr + E8390_CMD); // restore to page 0
+#endif
 
 	/* Reset card. Who knows what dain-bramaged state it was left in. */
 
@@ -625,6 +648,10 @@
 
 	dev->base_addr = ioaddr;
 
+#ifdef CONFIG_ARCH_ACTELM7
+	for(i = 0; i < 6; i++)
+		SA_prom[i] = ne_defethaddr[i];
+#endif
 #ifdef CONFIG_PLAT_MAPPI
 	outb_p(E8390_NODMA + E8390_PAGE1 + E8390_STOP,
 		ioaddr + E8390_CMD); /* 0x61 */
